73a99dabd7b3626582a418040e1ce6713a68ada9
[arvados.git] / build / run-library.sh
1 #!/bin/bash
2
3 # A library of functions shared by the various scripts in this directory.
4
5 # This is the timestamp about when we merged changed to include licenses
6 # with Arvados packages.  We use it as a heuristic to add revisions for
7 # older packages.
8 LICENSE_PACKAGE_TS=20151208015500
9
10 debug_echo () {
11     echo "$@" >"$STDOUT_IF_DEBUG"
12 }
13
14 find_easy_install() {
15     for version_suffix in "$@"; do
16         if "easy_install$version_suffix" --version >/dev/null 2>&1; then
17             echo "easy_install$version_suffix"
18             return 0
19         fi
20     done
21     cat >&2 <<EOF
22 $helpmessage
23
24 Error: easy_install$1 (from Python setuptools module) not found
25
26 EOF
27     exit 1
28 }
29
30 format_last_commit_here() {
31     local format="$1"; shift
32     TZ=UTC git log -n1 --first-parent "--format=format:$format" .
33 }
34
35 version_from_git() {
36   # Generates a version number from the git log for the current working
37   # directory, and writes it to stdout.
38   local git_ts git_hash
39   declare $(format_last_commit_here "git_ts=%ct git_hash=%h")
40   echo "0.1.$(date -ud "@$git_ts" +%Y%m%d%H%M%S).$git_hash"
41 }
42
43 nohash_version_from_git() {
44     version_from_git | cut -d. -f1-3
45 }
46
47 timestamp_from_git() {
48     format_last_commit_here "%ct"
49 }
50
51 handle_python_package () {
52   # This function assumes the current working directory is the python package directory
53   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
54     # This package doesn't need rebuilding.
55     return
56   fi
57   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
58   python setup.py $DASHQ_UNLESS_DEBUG sdist
59 }
60
61 handle_ruby_gem() {
62     local gem_name="$1"; shift
63     local gem_version="$(nohash_version_from_git)"
64     local gem_src_dir="$(pwd)"
65
66     if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
67         find -maxdepth 1 -name "${gem_name}-*.gem" -delete
68
69         # -q appears to be broken in gem version 2.2.2
70         $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
71     fi
72 }
73
74 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision"
75 package_go_binary() {
76     local src_path="$1"; shift
77     local prog="$1"; shift
78     local description="$1"; shift
79     local license_file="${1:-agpl-3.0.txt}"; shift
80
81     debug_echo "package_go_binary $src_path as $prog"
82
83     local basename="${src_path##*/}"
84
85     mkdir -p "$GOPATH/src/git.curoverse.com"
86     ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git"
87
88     cd "$GOPATH/src/git.curoverse.com/arvados.git/$src_path"
89     local version="$(version_from_git)"
90     local timestamp="$(timestamp_from_git)"
91
92     # If the command imports anything from the Arvados SDK, bump the
93     # version number and build a new package whenever the SDK changes.
94     if grep -qr git.curoverse.com/arvados .; then
95         cd "$GOPATH/src/git.curoverse.com/arvados.git/sdk/go"
96         if [[ $(timestamp_from_git) -gt "$timestamp" ]]; then
97             version=$(version_from_git)
98         fi
99     fi
100
101     cd $WORKSPACE/packages/$TARGET
102     go get "git.curoverse.com/arvados.git/$src_path"
103
104     declare -a switches=()
105     systemd_unit="$WORKSPACE/${src_path}/${prog}.service"
106     if [[ -e "${systemd_unit}" ]]; then
107         switches+=(
108             --after-install "${WORKSPACE}/build/go-python-package-scripts/postinst"
109             --before-remove "${WORKSPACE}/build/go-python-package-scripts/prerm"
110             "${systemd_unit}=/lib/systemd/system/${prog}.service")
111     fi
112     switches+=("$WORKSPACE/${license_file}=/usr/share/doc/$prog/${license_file}")
113
114     fpm_build "$GOPATH/bin/${basename}=/usr/bin/${prog}" "${prog}" 'Curoverse, Inc.' dir "${version}" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=${description}" "${switches[@]}"
115 }
116
117 default_iteration() {
118     local package_name="$1"; shift
119     local package_version="$1"; shift
120     local iteration=1
121     if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
122            [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
123         iteration=2
124     fi
125     echo $iteration
126 }
127
128 _build_rails_package_scripts() {
129     local pkgname="$1"; shift
130     local destdir="$1"; shift
131     local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
132     for scriptname in postinst prerm postrm; do
133         cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
134             >"$destdir/$scriptname" || return $?
135     done
136 }
137
138 handle_rails_package() {
139     local pkgname="$1"; shift
140     local srcdir="$1"; shift
141     local license_path="$1"; shift
142     local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
143     local version_file="$(mktemp --tmpdir "$pkgname-XXXXXXXX.version")" && (
144         set -e
145         _build_rails_package_scripts "$pkgname" "$scripts_dir"
146         cd "$srcdir"
147         mkdir -p tmp
148         version_from_git >"$version_file"
149         git rev-parse HEAD >git-commit.version
150         bundle package --all
151     )
152     if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
153         echo "ERROR: $pkgname package prep failed" >&2
154         rm -rf "$scripts_dir" "$version_file"
155         EXITCODE=1
156         return 1
157     fi
158     local railsdir="/var/www/${pkgname%-server}/current"
159     local -a pos_args=("$srcdir/=$railsdir" "$pkgname" "Curoverse, Inc." dir
160                        "$(cat "$version_file")")
161     local license_arg="$license_path=$railsdir/$(basename "$license_path")"
162     local -a switches=(--iteration=6
163                        --after-install "$scripts_dir/postinst"
164                        --before-remove "$scripts_dir/prerm"
165                        --after-remove "$scripts_dir/postrm")
166     # For some reason fpm excludes need to not start with /.
167     local exclude_root="${railsdir#/}"
168     # .git and packages are for the SSO server, which is built from its
169     # repository root.
170     local -a exclude_list=(.git packages tmp log coverage Capfile\* \
171                            config/deploy\* config/application.yml)
172     # for arvados-workbench, we need to have the (dummy) config/database.yml in the package
173     if  [[ "$pkgname" != "arvados-workbench" ]]; then
174       exclude_list+=('config/database.yml')
175     fi
176     for exclude in ${exclude_list[@]}; do
177         switches+=(-x "$exclude_root/$exclude")
178     done
179     fpm_build "${pos_args[@]}" "${switches[@]}" \
180               -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
181     rm -rf "$scripts_dir" "$version_file"
182 }
183
184 # Build packages for everything
185 fpm_build () {
186   # The package source.  Depending on the source type, this can be a
187   # path, or the name of the package in an upstream repository (e.g.,
188   # pip).
189   PACKAGE=$1
190   shift
191   # The name of the package to build.
192   PACKAGE_NAME=$1
193   shift
194   # Optional: the vendor of the package.  Should be "Curoverse, Inc." for
195   # packages of our own software.  Passed to fpm --vendor.
196   VENDOR=$1
197   shift
198   # The type of source package.  Passed to fpm -s.  Default "python".
199   PACKAGE_TYPE=${1:-python}
200   shift
201   # Optional: the package version number.  Passed to fpm -v.
202   VERSION=$1
203   shift
204
205   local default_iteration_value="$(default_iteration "$PACKAGE" "$VERSION")"
206
207   case "$PACKAGE_TYPE" in
208       python)
209           # All Arvados Python2 packages depend on Python 2.7.
210           # Make sure we build with that for consistency.
211           set -- "$@" --python-bin python2.7 \
212               --python-easyinstall "$EASY_INSTALL2" \
213               --python-package-name-prefix "$PYTHON2_PKG_PREFIX" \
214               --prefix "$PYTHON2_PREFIX" \
215               --python-install-lib "$PYTHON2_INSTALL_LIB" \
216               --python-install-data . \
217               --exclude "${PYTHON2_INSTALL_LIB#/}/tests" \
218               --depends "$PYTHON2_PACKAGE"
219           # Fix --iteration for #9242.
220           default_iteration_value=$(($default_iteration_value + 1))
221           ;;
222       python3)
223           # fpm does not actually support a python3 package type.  Instead
224           # we recognize it as a convenience shortcut to add several
225           # necessary arguments to fpm's command line later, after we're
226           # done handling positional arguments.
227           PACKAGE_TYPE=python
228           set -- "$@" --python-bin python3 \
229               --python-easyinstall "$EASY_INSTALL3" \
230               --python-package-name-prefix "$PYTHON3_PKG_PREFIX" \
231               --prefix "$PYTHON3_PREFIX" \
232               --python-install-lib "$PYTHON3_INSTALL_LIB" \
233               --python-install-data . \
234               --exclude "${PYTHON3_INSTALL_LIB#/}/tests" \
235               --depends "$PYTHON3_PACKAGE"
236           # Fix --iteration for #9242.
237           default_iteration_value=$(($default_iteration_value + 1))
238           ;;
239   esac
240
241   declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
242   if [ python = "$PACKAGE_TYPE" ] && [ deb = "$FORMAT" ]; then
243       # Dependencies are built from setup.py.  Since setup.py will never
244       # refer to Debian package iterations, it doesn't make sense to
245       # enforce those in the .deb dependencies.
246       COMMAND_ARR+=(--deb-ignore-iteration-in-dependencies)
247   fi
248
249   if [[ "${DEBUG:-0}" != "0" ]]; then
250     COMMAND_ARR+=('--verbose' '--log' 'info')
251   fi
252
253   if [[ -n "$PACKAGE_NAME" ]]; then
254     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
255   fi
256
257   if [[ "$VENDOR" != "" ]]; then
258     COMMAND_ARR+=('--vendor' "$VENDOR")
259   fi
260
261   if [[ "$VERSION" != "" ]]; then
262     COMMAND_ARR+=('-v' "$VERSION")
263   fi
264   # We can always add an --iteration here.  If another one is specified in $@,
265   # that will take precedence, as desired.
266   COMMAND_ARR+=(--iteration "$default_iteration_value")
267
268   if [[ python = "$PACKAGE_TYPE" ]] && [[ -e "${PACKAGE}/${PACKAGE_NAME}.service" ]]
269   then
270       COMMAND_ARR+=(
271           --after-install "${WORKSPACE}/build/go-python-package-scripts/postinst"
272           --before-remove "${WORKSPACE}/build/go-python-package-scripts/prerm"
273       )
274   fi
275
276   # Append --depends X and other arguments specified by fpm-info.sh in
277   # the package source dir. These are added last so they can override
278   # the arguments added by this script.
279   declare -a fpm_args=()
280   declare -a build_depends=()
281   declare -a fpm_depends=()
282   declare -a fpm_exclude=()
283   declare -a fpm_dirs=(
284       # source dir part of 'dir' package ("/source=/dest" => "/source"):
285       "${PACKAGE%%=/*}"
286       # backports ("llfuse==0.41.1" => "backports/python-llfuse")
287       "${WORKSPACE}/backports/${PACKAGE_TYPE}-${PACKAGE%%[<=>]*}")
288   if [[ -n "$PACKAGE_NAME" ]]; then
289       fpm_dirs+=("${WORKSPACE}/backports/${PACKAGE_NAME}")
290   fi
291   for pkgdir in "${fpm_dirs[@]}"; do
292       fpminfo="$pkgdir/fpm-info.sh"
293       if [[ -e "$fpminfo" ]]; then
294           debug_echo "Loading fpm overrides from $fpminfo"
295           source "$fpminfo"
296           break
297       fi
298   done
299   for pkg in "${build_depends[@]}"; do
300       if [[ $TARGET =~ debian|ubuntu ]]; then
301           pkg_deb=$(ls "$WORKSPACE/packages/$TARGET/$pkg_"*.deb | sort -rg | awk 'NR==1')
302           if [[ -e $pkg_deb ]]; then
303               echo "Installing build_dep $pkg from $pkg_deb"
304               dpkg -i "$pkg_deb"
305           else
306               echo "Attemping to install build_dep $pkg using apt-get"
307               apt-get install -y "$pkg"
308           fi
309           apt-get -y -f install
310       else
311           pkg_rpm=$(ls "$WORKSPACE/packages/$TARGET/$pkg"-[0-9]*.rpm | sort -rg | awk 'NR==1')
312           if [[ -e $pkg_rpm ]]; then
313               echo "Installing build_dep $pkg from $pkg_rpm"
314               rpm -i "$pkg_rpm"
315           else
316               echo "Attemping to install build_dep $pkg"
317               rpm -i "$pkg"
318           fi
319       fi
320   done
321   for i in "${fpm_depends[@]}"; do
322     COMMAND_ARR+=('--depends' "$i")
323   done
324   for i in "${fpm_exclude[@]}"; do
325     COMMAND_ARR+=('--exclude' "$i")
326   done
327
328   # Append remaining function arguments directly to fpm's command line.
329   for i; do
330     COMMAND_ARR+=("$i")
331   done
332
333   COMMAND_ARR+=("${fpm_args[@]}")
334
335   COMMAND_ARR+=("$PACKAGE")
336
337   debug_echo -e "\n${COMMAND_ARR[@]}\n"
338
339   FPM_RESULTS=$("${COMMAND_ARR[@]}")
340   FPM_EXIT_CODE=$?
341
342   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
343 }
344
345 # verify build results
346 fpm_verify () {
347   FPM_EXIT_CODE=$1
348   shift
349   FPM_RESULTS=$@
350
351   FPM_PACKAGE_NAME=''
352   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
353     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
354   fi
355
356   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
357     EXITCODE=1
358     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
359     echo
360     echo $FPM_RESULTS
361     echo
362   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
363     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
364   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
365     echo "Error building package for $1:\n $FPM_RESULTS"
366   fi
367 }
368
369 install_package() {
370   PACKAGES=$@
371   if [[ "$FORMAT" == "deb" ]]; then
372     $SUDO apt-get install $PACKAGES --yes
373   elif [[ "$FORMAT" == "rpm" ]]; then
374     $SUDO yum -q -y install $PACKAGES
375   fi
376 }
377
378 title () {
379     txt="********** $1 **********"
380     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
381 }
382
383 checkexit() {
384     if [[ "$1" != "0" ]]; then
385         title "!!!!!! $2 FAILED !!!!!!"
386         failures+=("$2 (`timer`)")
387     else
388         successes+=("$2 (`timer`)")
389     fi
390 }
391
392 timer_reset() {
393     t0=$SECONDS
394 }
395
396 timer() {
397     echo -n "$(($SECONDS - $t0))s"
398 }
399
400 report_outcomes() {
401     for x in "${successes[@]}"
402     do
403         echo "Pass: $x"
404     done
405
406     if [[ ${#failures[@]} == 0 ]]
407     then
408         echo "All test suites passed."
409     else
410         echo "Failures (${#failures[@]}):"
411         for x in "${failures[@]}"
412         do
413             echo "Fail: $x"
414         done
415     fi
416 }